// last time modified by Igor UA3DJY on 20200205
// -*- Mode: C++ -*-

#ifndef LogQSO_H
#define LogQSO_H

#ifdef QT5
#include <QtWidgets>
#else
#include <QtGui>
#endif

#include <QScopedPointer>
#include "Radio.hpp"

// ----->   ja2bqx
#include "logbook/logbook.h"
#include <QByteArray>
#include <QFile>
#include <QTextStream>

// <-----   ja2bqx


#include "Radio.hpp"

namespace Ui {
  class LogQSO;
}

class QSettings;
class Configuration;

class LogQSO : public QDialog
{
  Q_OBJECT

public:
  explicit LogQSO(QSettings *, Configuration const *, QWidget *parent = 0);
  ~LogQSO();
  void initLogQSO(QString const& hisCall, QString const& hisGrid, QString mode,
                  QString const& rptSent, QString const& rptRcvd, QString const& name, QDateTime const& dateTimeOn,
                  QDateTime const& dateTimeOff, Radio::Frequency dialFreq, bool autologging);
                  

  // -----> ja2bqx

QString m_filepath;

QString jtdxEntity;
QString thwCode;
QString thwEntityName;
QString entity_name;
QString search_call_str;
QString check_call;
QString countryName;
QString Qsl_Mark_str;

QString m_strDialFreq;
bool m_send_to_hamlog;
QString m_HamlogHdb_path;
QString send_to_hamlog_str;

unsigned int hdb_rec_org;
unsigned int hdb_rec_new;
unsigned int hdb_header;

QString  ary_searchPrefix[1010];
QString  ary_jtdxEntity[1010];

int len;
int ffp;
int ffp0;
int ffp1;
int ffp2;
int ffp3;
int ffp4;
int ffp5;
qint32  fffp0;

void get_thwCode_from_jtdxEntity ();
void get_thwCode_from_jtdxEntity_new ();

void get_entity_from_Unique_callsign_Suuji ();
void get_entity_from_Unique_callsign_ABCDEF ();
void get_entity_from_Unique_callsign_GHIJ ();
void get_entity_from_Unique_callsign_K ();
void get_entity_from_Unique_callsign_LMN ();
void get_entity_from_Unique_callsign_OPQRSTUV ();
void get_entity_from_Unique_callsign_WXYZ ();
void get_thw_qsl_mark();
void put_thw_qsl_mark();

QString fname;
int sd;
   // <----- ja2bqx

public slots:
  void accept();

signals:
  void acceptQSO (QDateTime const& QSO_date_off, QString const& call, QString const& grid
                  , Radio::Frequency dial_freq, QString const& mode
                  , QString const& rpt_sent, QString const& rpt_received
                  , QString const& tx_power, QString const& comments
                  , QString const& name, QDateTime const& QSO_date_on
                  , QString const& eqslcomments, QByteArray const& myadif2);

protected:
  void hideEvent (QHideEvent *);

private:
  void loadSettings ();
  void storeSettings () const;

  // ---> ja2bqx
  void get_hdb_keta_sub();
  void rewrite_hdb_rec_sub();
  void get_hdb_rec_org_sub();
  void append_Hamlog_hdb();
  void get_Entityfrom_callsign();
  void get_Unique_callsign_thw_code();
  void get_thw_code();

 QString  searchKey ;
 QString  searchPrefix ;
 QString  Entity ;
 QString  Entity_name;
 QString  thw_code ;

 qint32  Call_len;
 qint32 hisCall_len;
 qint32  ix;

 QStringList list;
 QStringList str;

 QString  thw_call;
 QString  thw_date;
 QString  thw_time;
 //QString  thw_code;
 QString  thw_grid;
 QString  thw_qsl;
 // thw_flag;
 QString  thw_hiss;
 QString  thw_myrs;
 QString  thw_freq;
 QString  thw_mode;
 QString  thw_name;
 QString  thw_qth;
 QString  thw_rmk1;
 QString  thw_rmk2;

 char  calls[20];
 char  date[4];
 char  time[2];
 char  code[6];
 char  grid[6];
 char  qsl[3];
 //char  flag;
 char  hiss[3];
 char  myrs[3];
 char  freq[7];
 char  mode[4];
 char  name[12];
 char  qth[28];
 char  rmk1[54];
 char  rmk2[54];

 unsigned int his_len;
 unsigned int my_len;
 unsigned int freq_len;
 unsigned int mode_len;
 unsigned int name_len;
 unsigned int qth_len;
 unsigned int rmk_len;

 QString  hisCall_left;
 QString  hisCall_right;
 qint32  hisCall_len_left;
 qint32  hisCall_len_right;

  // <--- ja2bqx

  QScopedPointer<Ui::LogQSO> ui;
  QSettings * m_settings;
  Configuration const * m_config;
  QString m_txPower;
  QString m_comments;
  QString m_eqslcomments;
  Radio::Frequency m_dialFreq;
  QString m_myCall;
  QString m_myGrid;
  QDateTime m_dateTimeOn;
  QDateTime m_dateTimeOff;
  bool m_send_to_eqsl;
  QString m_eqsl_username;
  QString m_eqsl_passwd;
  QString m_eqsl_nickname;
  QString m_tcp_server_name;
  uint m_tcp_server_port;
  uint m_eqsltimer;
  bool m_enable_tcp_connection;
  bool m_debug;
};

#endif // LogQSO_H
